#ifndef _COMMONGRAYPROC_H
#define _COMMONGRAYPROC_H

//! Convert double to uchar in the range 0..255 by clamping if out of range.
/*! Works for all number types */
template <class NumberType>
uchar toChar(NumberType d)
{
  if (d > 255) return 255;
  if (d < 0) return 0;
  return uchar(d);
}

//! Returns the square of the given number.
template <class NumberType>
NumberType sqr(NumberType d)
{
  return d*d;
}

//! Returns the absolute value of argument.
template <class NumberType>
NumberType absnum(NumberType d)
{
  if (d < 0)
    return -d;
  return d;
}

//! Returns the undirected angle between the two given directions.
/*! The angles are defined such that 0 corresponds to -90, and 255 to
    90. */
template <class NumberType>
NumberType deltaAngle(NumberType phi1, NumberType phi2)
{
  NumberType d = absnum(phi1 - phi2);
  if (d < 128)
    return d;
  return 256 - d;
}

#endif // _COMMONGRAYPROC_H
