#include "gdialog.h"
#include <qdialog.h>
#include <iostream.h>

//! Constructor for the GDialog class
/*! The dialog box is implemented with a QGridLayout. All the parameters for the Gabor filters are set using this dialog, and initially they have default values. */
GDialog::GDialog(QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0) : QDialog(parent,name,modal,f)
{
  topLayout = new QGridLayout(this,11,2,0,0,0);
  S = new QLineEdit("50",this,0);
  S->setMaxLength(8);
  topLayout->addWidget(S,0,0,0);
  K = new QLineEdit("1",this,0);
  K->setMaxLength(8);
  topLayout->addWidget(K,1,0,0);
  P = new QLineEdit("0",this,0);
  P->setMaxLength(8);
  topLayout->addWidget(P,2,0,0);
  a = new QLineEdit("0.05",this,0);
  a->setMaxLength(8);
  topLayout->addWidget(a,3,0,0);
  b = new QLineEdit("0.05",this,0);
  b->setMaxLength(8);
  topLayout->addWidget(b,4,0,0);
  x0 = new QLineEdit("0",this,0);
  x0->setMaxLength(8);
  topLayout->addWidget(x0,5,0,0);
  y0 = new QLineEdit("0",this,0);
  y0->setMaxLength(8);
  topLayout->addWidget(y0,6,0,0);
  u0 = new QLineEdit("0.08",this,0);
  u0->setMaxLength(8);
  topLayout->addWidget(u0,7,0,0);
  v0 = new QLineEdit("0.08",this,0);
  v0->setMaxLength(8);
  topLayout->addWidget(v0,8,0,0);
  theta = new QLineEdit("0",this,0);
  theta->setMaxLength(8);
  topLayout->addWidget(theta,9,0,0);
  apply = new QPushButton("Apply",this,0);
  topLayout->addWidget(apply,10,0,0);
  close = new QPushButton("Close",this,0);
  topLayout->addWidget(close,10,1,0);

  connect(apply,SIGNAL(clicked()),this,SLOT(send()));
  connect(close,SIGNAL(clicked()),this,SLOT(accept()));

}


GDialog::~GDialog()
{
}


void GDialog::send()
{
  emit sendParam(S->text(),K->text(),P->text(),a->text(),b->text(),x0->text(),y0->text(),u0->text(),v0->text(),theta->text());
}



