#ifndef GDIALOG_H
#define GDIALOG_H

#include <qdialog.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qpushbutton.h>

//! The class for the dialogbox for the setting the Gabor parameters.
/*! This class is for the dialog box for Gabor filter. */
class GDialog : public QDialog
{
  Q_OBJECT // keyword for meta object compiler

 private:
  QGridLayout *topLayout;
  QLineEdit *S, *K, *P, *a, *b, *theta, *x0, *y0, *u0, *v0;
  QPushButton *apply;
  QPushButton *close;

 public:
  GDialog(QWidget *parent=0, const char *name=0, bool modal=FALSE, WFlags f=0);
  ~GDialog();

 private slots:
  void send();

 signals:
  void sendParam(QString, QString, QString, QString, QString, QString, QString, QString, QString, QString);

};


#endif
