#ifndef GIMSHOW_H
#define GIMSHOW_H

#include <qwidget.h>          
#include <qstring.h>
#include <qrect.h>
#include <qprogressdialog.h>      
#include <complex.h>       
#include "gimshow.h"
#include "grayprocessingimage.h"

#define MINWIDGETSIZE 200

//! The imshow class for the QtGabor2D application
/*! This class is just a wrapper for the grayprocessingimage to be displayed. */
class GImShow : public QWidget
{
  Q_OBJECT // keyword for meta object compiler

 private:
  GrayProcessingImage *viewimage, *origimage, *filterreal, *filterimag, *filtermag, *resultreal, *resultimag, *resultmag;
  QProgressDialog *progress;
  QPainter *paint;
  QRgb temprgb;
  QRect rec;
  complex<double> **filter, **result;
  double maxfilterreal, minfilterreal, maxfilterimag, minfilterimag, maxfiltermag, minfiltermag, maxresultreal, minresultreal, maxresultimag, minresultimag, maxresultmag, minresultmag;  
  double **procimg;
  double K, P, a, b, theta, x0, y0, u0, v0, xoff, yoff, re, im, rx, ry;
  int totprogsteps, temp;
  int S, size; 

 protected:
  void paintEvent(QPaintEvent *e);

 public:
  int width();
  int height();
  bool loadImage(const char *filename);
  bool saveImage(const char *filename);
  GImShow(QWidget *parent=0, const char *name=0, WFlags f=0);
  ~GImShow();

 public slots:
  void slotViewOrigImage();
  void slotViewFilterReal();
  void slotViewFilterImag();
  void slotViewFilterMag();
  void slotViewResultReal();
  void slotViewResultImag();
  void slotViewResultMag();
  void slotSetFilter(QString Ss, QString Ks, QString Ps, QString as, QString bs, QString x0s, QString y0s, QString u0s, QString v0s, QString rs);

};


#endif
